## zxing-cpp 1.0.8%2Bds2

=== debian/watch ===
version=4
opts="repack,compression=xz,repacksuffix=+ds, \
 dversionmangle=s/\+ds\d//, \
 repackdversionmangle=s/\+ds\d*$//, \
 filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%zxing-cpp_$1.orig.tar.gz%" \
 https://github.com/nu-book/zxing-cpp/tags \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## zxing-cpp 1.0.8+ds2

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.1.3)

set (ZXING_VERSION_MAJOR 1)
set (ZXING_VERSION_MINOR 0)
set (ZXING_VERSION_PATCH 7)

project (ZXingCpp VERSION ${ZXING_VERSION_MAJOR}.${ZXING_VERSION_MINOR}.${ZXING_VERSION_PATCH})

set (ENABLE_ENCODERS ON CACHE BOOL "Check to include encoders")
set (ENABLE_DECODERS ON CACHE BOOL "Check to include decoders")
IF (NOT WIN32)
set (BUILD_SHARED_LIBRARY ON CACHE BOOL "Check to build ZXingCore as shared library")
ELSE ()
set (BUILD_SHARED_LIBRARY OFF CACHE BOOL "Check to build ZXingCore as shared library")
ENDIF ()

if (MSVC)
    set (LINK_CPP_STATICALLY OFF CACHE BOOL "MSVC only, check to link statically standard library (/MT and /MTd)")

    add_definitions (-DUNICODE -D_UNICODE)
    set (CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} /Oi /GS-")
    set (CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /Oi /GS-")
    if (LINK_CPP_STATICALLY)
        set (CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} /MT")
        set (CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MT")
        set (CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} /MTd")
        set (CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MTd")
    endif()
else()
    set (CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -D_DEBUG")
    set (CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -D_DEBUG")
endif()

set (DEFAULT_BUILD_TYPE "Release")

if (NOT CMAKE_BUILD_TYPE)
	message (STATUS "Setting build type to '${DEFAULT_BUILD_TYPE}' as none was specified.")
	set (CMAKE_BUILD_TYPE "${DEFAULT_BUILD_TYPE}" CACHE STRING "Choose the type of build." FORCE)
    set_property (CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

if (BUILD_SHARED_LIBRARY)
    set (BUILD_SHARED_LIBS ON)
    set (CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
endif()

add_subdirectory (core)

set(TARGET_ZXING "ZXingCore" CACHE STRING "The name for the ZXing library")

set_target_properties (${TARGET_ZXING} PROPERTIES VERSION ${PROJECT_VERSION})
set_target_properties (${TARGET_ZXING} PROPERTIES SOVERSION ${ZXING_VERSION_MAJOR})

set (CMAKECONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/ZXing")

install (
    EXPORT ZXingTargets
    DESTINATION ${CMAKECONFIG_INSTALL_DIR} NAMESPACE ZXing::
)

install (
    DIRECTORY core/src/
    DESTINATION include/ZXing
    FILES_MATCHING PATTERN "*.h"
)

configure_file (
    core/ZXVersion.h.in
    ZXVersion.h
)

install (
    FILES "${CMAKE_CURRENT_BINARY_DIR}/ZXVersion.h"
    DESTINATION include/ZXing
)

# PC file generation.
if (NOT DEFINED INSTALLDIR)
	set (INSTALLDIR ${CMAKE_INSTALL_PREFIX})
	get_filename_component(INSTALLDIR ${INSTALLDIR} ABSOLUTE)
endif()

IF (NOT WIN32)
    configure_file(zxing.pc.in zxing.pc @ONLY)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/zxing.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
ENDIF()

include (CMakePackageConfigHelpers)

configure_package_config_file (
    core/ZXingConfig.cmake.in
    ZXingConfig.cmake
    INSTALL_DESTINATION ${CMAKECONFIG_INSTALL_DIR}
)

install (
    FILES "${CMAKE_CURRENT_BINARY_DIR}/ZXingConfig.cmake"
    DESTINATION ${CMAKECONFIG_INSTALL_DIR}
)

=== core/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.1.3)

if (NOT DEFINED ENABLE_ENCODERS)
    set (ENABLE_ENCODERS OFF)
endif()

if (NOT DEFINED ENABLE_DECODERS)
    set (ENABLE_DECODERS ON)
endif()

set (ZXING_CORE_DEFINES)
if (WINRT)
    set (ZXING_CORE_DEFINES ${ZXING_CORE_DEFINES}
        -DWINRT
    )
endif()

set (ZXING_CORE_LOCAL_DEFINES)
if (MSVC)
    set (ZXING_CORE_LOCAL_DEFINES ${ZXING_CORE_LOCAL_DEFINES}
        -D_SCL_SECURE_NO_WARNINGS
        -D_CRT_SECURE_NO_WARNINGS
        -D_CRT_NONSTDC_NO_WARNINGS
        -DNOMINMAX
    )
else()
    set (ZXING_CORE_LOCAL_DEFINES ${ZXING_CORE_LOCAL_DEFINES}
        -Wall -Wextra -Wno-missing-braces)
endif()

set (CMAKE_CXX_STANDARD 14)


################# Source files

set (COMMON_FILES
    src/BarcodeFormat.h
    src/BarcodeFormat.cpp
    src/BitArray.h
    src/BitArray.cpp
    src/BitHacks.h
    src/BitMatrix.h
    src/BitMatrix.cpp
    src/ByteArray.h
    src/CharacterSet.h
    src/CharacterSetECI.h
    src/CharacterSetECI.cpp
    src/CustomData.h
    src/GenericGF.h
    src/GenericGF.cpp
    src/GenericGFPoly.h
    src/GenericGFPoly.cpp
    src/TextUtfEncoding.h
    src/TextUtfEncoding.cpp
    src/ZXBigInteger.h
    src/ZXBigInteger.cpp
    src/ZXConfig.h
    src/ZXFilesystem.h
    src/ZXNullable.h
    src/ZXNumeric.h
    src/ZXContainerAlgorithms.h
    src/ZXStrConvWorkaround.h
    src/ZXTestSupport.h
)
if (ENABLE_DECODERS)
    set (COMMON_FILES ${COMMON_FILES}
        src/BinaryBitmap.h
        src/BitSource.h
        src/BitSource.cpp
        src/DecodeHints.h
        src/DecodeHints.cpp
        src/DecodeStatus.h
        src/DecodeStatus.cpp
        src/DecoderResult.h
        src/DetectorResult.h
        src/GenericLuminanceSource.h
        src/GenericLuminanceSource.cpp
        src/GlobalHistogramBinarizer.h
        src/GlobalHistogramBinarizer.cpp
        src/GridSampler.h
        src/GridSampler.cpp
        src/HybridBinarizer.h
        src/HybridBinarizer.cpp
        src/LuminanceSource.h
        src/LuminanceSource.cpp
        src/MultiFormatReader.h
        src/MultiFormatReader.cpp
        src/PerspectiveTransform.h
        src/PerspectiveTransform.cpp
        src/Reader.h
        src/ReadBarcode.h
        src/ReadBarcode.cpp
        src/ReedSolomonDecoder.h
        src/ReedSolomonDecoder.cpp
        src/Result.h
        src/Result.cpp
        src/ResultMetadata.h
        src/ResultMetadata.cpp
        src/ResultPoint.h
        src/ResultPoint.cpp
        src/TextDecoder.h
        src/TextDecoder.cpp
        src/WhiteRectDetector.h
        src/WhiteRectDetector.cpp
    )
endif()
if (ENABLE_ENCODERS)
    set (COMMON_FILES ${COMMON_FILES}
        src/ByteMatrix.h
        src/ReedSolomonEncoder.h
        src/ReedSolomonEncoder.cpp
        src/TextEncoder.h
        src/TextEncoder.cpp
        src/MultiFormatWriter.h
        src/MultiFormatWriter.cpp
    )
endif()


set (AZTEC_FILES
)
if (ENABLE_DECODERS)
    set (AZTEC_FILES ${AZTEC_FILES}
        src/aztec/AZDecoder.h
        src/aztec/AZDecoder.cpp
        src/aztec/AZDetector.h
        src/aztec/AZDetector.cpp
        src/aztec/AZDetectorResult.h
        src/aztec/AZReader.h
        src/aztec/AZReader.cpp
    )
endif()
if (ENABLE_ENCODERS)
    set (AZTEC_FILES ${AZTEC_FILES}
        src/aztec/AZEncodingState.h
        src/aztec/AZEncoder.h
        src/aztec/AZEncoder.cpp
        src/aztec/AZHighLevelEncoder.h
        src/aztec/AZHighLevelEncoder.cpp
        src/aztec/AZToken.h
        src/aztec/AZToken.cpp
        src/aztec/AZWriter.h
        src/aztec/AZWriter.cpp
    )
endif()


set (DATAMATRIX_FILES
)
if (ENABLE_DECODERS)
    set (DATAMATRIX_FILES ${DATAMATRIX_FILES}
        src/datamatrix/DMBitMatrixParser.h
        src/datamatrix/DMBitMatrixParser.cpp
        src/datamatrix/DMECB.h
        src/datamatrix/DMDataBlock.h
        src/datamatrix/DMDataBlock.cpp
        src/datamatrix/DMDecoder.h
        src/datamatrix/DMDecoder.cpp
        src/datamatrix/DMDetector.h
        src/datamatrix/DMDetector.cpp
        src/datamatrix/DMVersion.h
        src/datamatrix/DMVersion.cpp
        src/datamatrix/DMReader.h
        src/datamatrix/DMReader.cpp
    )
endif()
if (ENABLE_ENCODERS)
    set (DATAMATRIX_FILES ${DATAMATRIX_FILES}
        src/datamatrix/DMECEncoder.h
        src/datamatrix/DMECEncoder.cpp
        src/datamatrix/DMEncoderContext.h
        src/datamatrix/DMDefaultPlacement.h
        src/datamatrix/DMDefaultPlacement.cpp
        src/datamatrix/DMHighLevelEncoder.h
        src/datamatrix/DMHighLevelEncoder.cpp
        src/datamatrix/DMSymbolInfo.h
        src/datamatrix/DMSymbolInfo.cpp
        src/datamatrix/DMSymbolShape.h
        src/datamatrix/DMWriter.h
        src/datamatrix/DMWriter.cpp
    )
endif()


set (MAXICODE_FILES
)
if (ENABLE_DECODERS)
    set (MAXICODE_FILES ${MAXICODE_FILES}
        src/maxicode/MCBitMatrixParser.h
        src/maxicode/MCBitMatrixParser.cpp
        src/maxicode/MCDecoder.h
        src/maxicode/MCDecoder.cpp
        src/maxicode/MCReader.h
        src/maxicode/MCReader.cpp
    )
endif()


set (ONED_FILES
    src/oned/ODUPCEANCommon.h
    src/oned/ODUPCEANCommon.cpp
    src/oned/ODCode128Patterns.h
    src/oned/ODCode128Patterns.cpp
)
if (ENABLE_DECODERS)
    set (ONED_FILES ${ONED_FILES}
        src/oned/ODCodabarReader.h
        src/oned/ODCodabarReader.cpp
        src/oned/ODCode39Reader.h
        src/oned/ODCode39Reader.cpp
        src/oned/ODCode93Reader.h
        src/oned/ODCode93Reader.cpp
        src/oned/ODCode128Reader.h
        src/oned/ODCode128Reader.cpp
        src/oned/ODEAN8Reader.h
        src/oned/ODEAN8Reader.cpp
        src/oned/ODEAN13Reader.h
        src/oned/ODEAN13Reader.cpp
        src/oned/ODEANManufacturerOrgSupport.h
        src/oned/ODEANManufacturerOrgSupport.cpp
        src/oned/ODITFReader.h
        src/oned/ODITFReader.cpp
        src/oned/ODMultiUPCEANReader.h
        src/oned/ODMultiUPCEANReader.cpp
        src/oned/ODReader.h
        src/oned/ODReader.cpp
        src/oned/ODRowReader.h
        src/oned/ODRowReader.cpp
        src/oned/ODRSS14Reader.h
        src/oned/ODRSS14Reader.cpp
        src/oned/ODRSSExpandedReader.h
        src/oned/ODRSSExpandedReader.cpp
        src/oned/ODUPCAReader.h
        src/oned/ODUPCAReader.cpp
        src/oned/ODUPCEANExtensionSupport.h
        src/oned/ODUPCEANExtensionSupport.cpp
        src/oned/ODUPCEANReader.h
        src/oned/ODUPCEANReader.cpp
        src/oned/ODUPCEReader.h
        src/oned/ODUPCEReader.cpp
    )
endif()
if (ENABLE_ENCODERS)
    set (ONED_FILES ${ONED_FILES}
        src/oned/ODCodabarWriter.h
        src/oned/ODCodabarWriter.cpp
        src/oned/ODCode39Writer.h
        src/oned/ODCode39Writer.cpp
        src/oned/ODCode93Writer.h
        src/oned/ODCode93Writer.cpp
        src/oned/ODCode128Writer.h
        src/oned/ODCode128Writer.cpp
        src/oned/ODEAN8Writer.h
        src/oned/ODEAN8Writer.cpp
        src/oned/ODEAN13Writer.h
        src/oned/ODEAN13Writer.cpp
        src/oned/ODITFWriter.h
        src/oned/ODITFWriter.cpp
        src/oned/ODUPCEWriter.h
        src/oned/ODUPCEWriter.cpp
        src/oned/ODUPCAWriter.h
        src/oned/ODUPCAWriter.cpp
        src/oned/ODWriterHelper.h
        src/oned/ODWriterHelper.cpp
    )
endif()


set (ONED_RSS_FILES
)
if (ENABLE_DECODERS)
    set (ONED_RSS_FILES ${ONED_RSS_FILES}
        src/oned/rss/ODRSSDataCharacter.h
        src/oned/rss/ODRSSExpandedBinaryDecoder.h
        src/oned/rss/ODRSSExpandedBinaryDecoder.cpp
        src/oned/rss/ODRSSExpandedPair.h
        src/oned/rss/ODRSSExpandedRow.h
        src/oned/rss/ODRSSFieldParser.h
        src/oned/rss/ODRSSFieldParser.cpp
        src/oned/rss/ODRSSFinderPattern.h
        src/oned/rss/ODRSSGenericAppIdDecoder.h
        src/oned/rss/ODRSSGenericAppIdDecoder.cpp
        src/oned/rss/ODRSSPair.h
        src/oned/rss/ODRSSReaderHelper.h
        src/oned/rss/ODRSSReaderHelper.cpp
    )
endif()


set (PDF417_FILES
)
if (ENABLE_DECODERS)
    set (PDF417_FILES ${PDF417_FILES}
        src/pdf417/PDFBarcodeMetadata.h
        src/pdf417/PDFBarcodeValue.h
        src/pdf417/PDFBarcodeValue.cpp
        src/pdf417/PDFBoundingBox.h
        src/pdf417/PDFBoundingBox.cpp
        src/pdf417/PDFCodeword.h
        src/pdf417/PDFCodewordDecoder.h
        src/pdf417/PDFCodewordDecoder.cpp
        src/pdf417/PDFDecodedBitStreamParser.h
        src/pdf417/PDFDecodedBitStreamParser.cpp
        src/pdf417/PDFDecoderResultExtra.h
        src/pdf417/PDFDetectionResult.h
        src/pdf417/PDFDetectionResult.cpp
        src/pdf417/PDFDetectionResultColumn.h
        src/pdf417/PDFDetectionResultColumn.cpp
        src/pdf417/PDFDetector.h
        src/pdf417/PDFDetector.cpp
        src/pdf417/PDFModulusGF.h
        src/pdf417/PDFModulusGF.cpp
        src/pdf417/PDFModulusPoly.h
        src/pdf417/PDFModulusPoly.cpp
        src/pdf417/PDFReader.h
        src/pdf417/PDFReader.cpp
        src/pdf417/PDFScanningDecoder.h
        src/pdf417/PDFScanningDecoder.cpp
    )
endif()
if (ENABLE_ENCODERS)
    set (PDF417_FILES ${PDF417_FILES}
        src/pdf417/PDFCompaction.h
        src/pdf417/PDFEncoder.h
        src/pdf417/PDFEncoder.cpp
        src/pdf417/PDFHighLevelEncoder.h
        src/pdf417/PDFHighLevelEncoder.cpp
        src/pdf417/PDFWriter.h
        src/pdf417/PDFWriter.cpp
    )
endif()


set (QRCODE_FILES
    src/qrcode/QRCodecMode.h
    src/qrcode/QRCodecMode.cpp
    src/qrcode/QRErrorCorrectionLevel.h
    src/qrcode/QRErrorCorrectionLevel.cpp
    src/qrcode/QRVersion.h
    src/qrcode/QRVersion.cpp
)
if (ENABLE_DECODERS)
    set (QRCODE_FILES ${QRCODE_FILES}
        src/qrcode/QRAlignmentPattern.h
        src/qrcode/QRAlignmentPattern.cpp
        src/qrcode/QRAlignmentPatternFinder.h
        src/qrcode/QRAlignmentPatternFinder.cpp
        src/qrcode/QRBitMatrixParser.h
        src/qrcode/QRBitMatrixParser.cpp
        src/qrcode/QRDataBlock.h
        src/qrcode/QRDataBlock.cpp
        src/qrcode/QRDataMask.h
        src/qrcode/QRDataMask.cpp
        src/qrcode/QRDecoder.h
        src/qrcode/QRDecoder.cpp
        src/qrcode/QRDecoderMetadata.h
        src/qrcode/QRDetector.h
        src/qrcode/QRDetector.cpp
        src/qrcode/QRECB.h
        src/qrcode/QRFinderPattern.h
        src/qrcode/QRFinderPattern.cpp
        src/qrcode/QRFinderPatternFinder.h
        src/qrcode/QRFinderPatternFinder.cpp
        src/qrcode/QRFinderPatternInfo.h
        src/qrcode/QRFormatInformation.h
        src/qrcode/QRFormatInformation.cpp
        src/qrcode/QRReader.h
        src/qrcode/QRReader.cpp
    )
endif()
if (ENABLE_ENCODERS)
    set (QRCODE_FILES ${QRCODE_FILES}
        src/qrcode/QREncoder.h
        src/qrcode/QREncoder.cpp
        src/qrcode/QREncodeResult.h
        src/qrcode/QRMaskUtil.h
        src/qrcode/QRMaskUtil.cpp
        src/qrcode/QRMatrixUtil.h
        src/qrcode/QRMatrixUtil.cpp
        src/qrcode/QRWriter.h
        src/qrcode/QRWriter.cpp
    )
endif()


set (TEXT_CODEC_FILES
    src/textcodec/Big5MapTable.h
    src/textcodec/Big5MapTable.cpp
    src/textcodec/KRHangulMapping.h
    src/textcodec/KRHangulMapping.cpp
)
if (ENABLE_DECODERS)
    set (TEXT_CODEC_FILES ${TEXT_CODEC_FILES}
        src/textcodec/Big5TextDecoder.h
        src/textcodec/Big5TextDecoder.cpp
        src/textcodec/GBTextDecoder.h
        src/textcodec/GBTextDecoder.cpp
        src/textcodec/JPTextDecoder.h
        src/textcodec/JPTextDecoder.cpp
        src/textcodec/KRTextDecoder.h
        src/textcodec/KRTextDecoder.cpp
    )
endif()
if (ENABLE_ENCODERS)
    set (TEXT_CODEC_FILES ${TEXT_CODEC_FILES}
        src/textcodec/Big5TextEncoder.h
        src/textcodec/Big5TextEncoder.cpp
        src/textcodec/GBTextEncoder.h
        src/textcodec/GBTextEncoder.cpp
        src/textcodec/JPTextEncoder.h
        src/textcodec/JPTextEncoder.cpp
        src/textcodec/KRTextEncoder.h
        src/textcodec/KRTextEncoder.cpp
    )
endif()

source_group (Sources FILES ${COMMON_FILES})
source_group (Sources\\aztec FILES ${AZTEC_FILES})
source_group (Sources\\datamatrix FILES ${DATAMATRIX_FILES})

=== example/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.1.3)

project (ZXingExamples)

set (ENABLE_ENCODERS ON CACHE BOOL "Check to include encoders")
set (ENABLE_DECODERS ON CACHE BOOL "Check to include decoders")

add_definitions (-DUNICODE -D_UNICODE)

if (MSVC)
    add_definitions (-D_SCL_SECURE_NO_WARNINGS -D_CRT_SECURE_NO_WARNINGS -D_CRT_NONSTDC_NO_WARNINGS -DNOMINMAX)

    set (CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} /Oi /GS-")
    set (CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /Oi /GS-")
else()
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra")
    set (CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -D_DEBUG")
    set (CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -D_DEBUG")
endif()

add_subdirectory (${CMAKE_CURRENT_SOURCE_DIR}/../core ${CMAKE_BINARY_DIR}/ZXingCore)

if (ENABLE_DECODERS)
    add_executable (scan_image
        scan_image.cpp
    )
    
    target_include_directories (scan_image
        PRIVATE ../thirdparty/stb
    )

    target_compile_options (scan_image PRIVATE -DLODEPNG_NO_COMPILE_ENCODER)

    if ("${CMAKE_CXX_COMPILER_ID}" MATCHES "GNU")
        target_compile_options (scan_image PRIVATE -std=c++11)
    elseif (APPLE)
        target_compile_options (scan_image PRIVATE -std=c++11 -stdlib=libc++)
    endif()

    target_link_libraries (scan_image ZXingCore)

endif()

if (ENABLE_ENCODERS)
    add_executable (generate_image
        generate_image.cpp
    )
    
    target_include_directories (generate_image
        PRIVATE ../thirdparty/stb
    )

    target_compile_options (generate_image PRIVATE -DLODEPNG_NO_COMPILE_DECODER)
    
    if ("${CMAKE_CXX_COMPILER_ID}" MATCHES "GNU")
        target_compile_options (generate_image PRIVATE -std=c++11)
    elseif (APPLE)
        target_compile_options (generate_image PRIVATE -std=c++11 -stdlib=libc++)
    endif()

    target_link_libraries (generate_image ZXingCore)

endif()

=== wrappers/gdiplus/CMakeLists.txt ===
if (${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR})
    # this is the top level project
    cmake_minimum_required (VERSION 2.8.12)

    project (ZXingGdiPlus)

    set (ENABLE_ENCODERS OFF CACHE BOOL "Check to include encoders")
    set (ENABLE_DECODERS ON CACHE BOOL "Check to include decoders")
    set (LINK_CPP_STATICALLY OFF CACHE BOOL "MSVC only, check to link statically standard library (/MT and /MTd)")

    add_definitions (-DUNICODE -D_UNICODE)
    
    if (MSVC AND LINK_CPP_STATICALLY)
        set (CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} /MT")
        set (CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MT")
        set (CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} /MTd")
        set (CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MTd")
    endif()
endif()

if (NOT DEFINED ENABLE_ENCODERS)
    set (ENABLE_ENCODERS OFF)
endif()

if (NOT DEFINED ENABLE_DECODERS)
    set (ENABLE_DECODERS ON)
endif()

add_subdirectory (${CMAKE_CURRENT_SOURCE_DIR}/../../core ${CMAKE_BINARY_DIR}/ZXingCore)
    
set (LOCAL_COMMON_FILES
    GdiplusInit.h
    GdiplusInit.cpp
)
if (ENABLE_DECODERS)
    set (DECODERS_FILES
        ImageReader.h
        ImageReader.cpp
        BarcodeReader.h
        BarcodeReader.cpp
    )
endif()
if (ENABLE_ENCODERS)
	set (ENCODERS_FILES
		ImageWriter.h
		ImageWriter.cpp
        BarcodeGenerator.h
        BarcodeGenerator.cpp
	)
endif()

source_group (Sources FILES
    ${LOCAL_COMMON_FILES}
	${DECODERS_FILES}
	${ENCODERS_FILES}
)

add_library (ZXingGdiPlus
    ${LOCAL_COMMON_FILES}
    ${DECODERS_FILES}
    ${ENCODERS_FILES}
)

target_include_directories (ZXingGdiPlus
    PUBLIC .
)

target_link_libraries (ZXingGdiPlus
    PRIVATE ZXingCore gdiplus.lib
)

target_compile_options (ZXingGdiPlus
    PUBLIC -DGDIPVER=0x0110
)

=== debian/changelog ===
zxing-cpp (1.0.8+ds2-2build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:29:24 +0100

zxing-cpp (1.0.8+ds2-2) unstable; urgency=high

  * Source-only upload to allow testing migration.

 -- Boyuan Yang <byang@debian.org>  Thu, 23 Jan 2020 10:39:58 -0500

zxing-cpp (1.0.8+ds2-1) unstable; urgency=medium

  * Initial release.

 -- Boyuan Yang <byang@debian.org>  Tue, 21 Jan 2020 16:51:37 -0500

=== debian/control ===
Source: zxing-cpp
Section: libs
Priority: optional
Maintainer: Boyuan Yang <byang@debian.org>
Build-Depends:
 debhelper-compat (= 12),
 cmake (>= 3.1.2),
Rules-Requires-Root: no
Standards-Version: 4.5.0
Homepage: https://github.com/nu-book/zxing-cpp
Vcs-Git: https://salsa.debian.org/debian/zxing-cpp.git
Vcs-Browser: https://salsa.debian.org/debian/zxing-cpp

Package: libzxingcore-dev
Architecture: any
Section: libdevel
Depends:
 ${misc:Depends},
 libzxingcore1 (= ${binary:Version}),
Description: C++ port of ZXing library (development files)
 This project is a C++ port of ZXing Library. It is a pure C++14
 implementation with little third-party dependencies. The library
 provides stateless, thread-safe readers and generators to process
 QR Codes.
 .
 This package provides development files for zxing-cpp library.

Package: libzxingcore1
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: C++ port of ZXing library (library files)
 This project is a C++ port of ZXing Library. It is a pure C++14
 implementation with little third-party dependencies. The library
 provides stateless, thread-safe readers and generators to process
 QR Codes.
 .
 This package provides library files for zxing-cpp library.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#  # Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1
#
# # see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
#
# # see ENVIRONMENT in dpkg-buildflags(1)
# # package maintainers to append CFLAGS
# #export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# # package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_missing:
	dh_missing --fail-missing

## zxing-cpp 1.1.0

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.10)

project (ZXing VERSION "1.1.0" LANGUAGES CXX)

option (BUILD_WRITERS "Build with writer support (encoders)" ON)
option (BUILD_READERS "Build with reader support (decoders)" ON)
option (BUILD_EXAMPLES "Build the example barcode reader/writer applicatons" ON)
option (BUILD_BLACKBOX_TESTS "Build the black box reader/writer tests" ON)
option (BUILD_UNIT_TESTS "Build the unit tests (don't enable for production builds)" OFF)
option (BUILD_PYTHON_MODULE "Build the python module" OFF)

if (WIN32)
    option (BUILD_SHARED_LIBS "Build and link as shared library" OFF)
else()
    option (BUILD_SHARED_LIBS "Build and link as shared library" ON)
endif()

if (MSVC)
    option (LINK_CPP_STATICALLY "MSVC only, link standard library statically (/MT and /MTd)" OFF)

    add_definitions (-DUNICODE -D_UNICODE)
    set (CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} /Oi /GS-")
    set (CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /Oi /GS-")
    if (LINK_CPP_STATICALLY)
        set (CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} /MT")
        set (CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MT")
        set (CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} /MTd")
        set (CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MTd")
    endif()
endif()

if (NOT CMAKE_BUILD_TYPE)
    set (DEFAULT_BUILD_TYPE "Release")
    message (STATUS "Setting build type to '${DEFAULT_BUILD_TYPE}' as none was specified.")
    set (CMAKE_BUILD_TYPE "${DEFAULT_BUILD_TYPE}" CACHE STRING "Choose the type of build." FORCE)
    set_property (CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

if (BUILD_SHARED_LIBS)
    set (CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
endif()

# force the default c++ standard to c++-14 to fail if we depend on c++-17 features
set (CMAKE_CXX_STANDARD 14)
set (CMAKE_CXX_EXTENSIONS OFF)

if (BUILD_UNIT_TESTS)
    add_definitions (-DZXING_BUILD_FOR_TEST)
    if (NOT BUILD_WRITERS OR NOT BUILD_READERS)
        message("Note: To build with unit tests, the library will be build with READERS and WRITERS.")
        set (BUILD_WRITERS ON)
        set (BUILD_READERS ON)
    endif()
endif()

add_subdirectory (core)

enable_testing()

if (BUILD_EXAMPLES)
    add_subdirectory (example)
endif()
if (BUILD_BLACKBOX_TESTS)
    add_subdirectory (test/blackbox)
endif()
if (BUILD_UNIT_TESTS)
    add_subdirectory (test/unit)
endif()
if (BUILD_PYTHON_MODULE)
    add_subdirectory (wrappers/python)
endif()

set (CMAKECONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/ZXing")

install (
    EXPORT ZXingTargets
    DESTINATION ${CMAKECONFIG_INSTALL_DIR} NAMESPACE ZXing::
)

install (
    DIRECTORY core/src/
    DESTINATION include/ZXing
    FILES_MATCHING PATTERN "*.h"
)

configure_file (
    core/ZXVersion.h.in
    ZXVersion.h
)

install (
    FILES "${CMAKE_CURRENT_BINARY_DIR}/ZXVersion.h"
    DESTINATION include/ZXing
)

# PC file generation.
if (NOT DEFINED INSTALLDIR)
    set (INSTALLDIR ${CMAKE_INSTALL_PREFIX})
    get_filename_component(INSTALLDIR ${INSTALLDIR} ABSOLUTE)
endif()

IF (NOT WIN32)
    configure_file(zxing.pc.in zxing.pc @ONLY)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/zxing.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
ENDIF()

include (CMakePackageConfigHelpers)

write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/ZXingConfigVersion.cmake"
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY AnyNewerVersion
)

configure_package_config_file (
    core/ZXingConfig.cmake.in
    ZXingConfig.cmake
    INSTALL_DESTINATION ${CMAKECONFIG_INSTALL_DIR}
)

install (
    FILES
        "${CMAKE_CURRENT_BINARY_DIR}/ZXingConfig.cmake"
        "${CMAKE_CURRENT_BINARY_DIR}/ZXingConfigVersion.cmake"
    DESTINATION ${CMAKECONFIG_INSTALL_DIR}
)

=== test/blackbox/CMakeLists.txt ===
set (CMAKE_CXX_STANDARD 17)

if (BUILD_READERS)
    add_executable (ReaderTest
        TestReaderMain.cpp
        ImageLoader.h
        ImageLoader.cpp
        Pdf417MultipleCodeReader.h
        Pdf417MultipleCodeReader.cpp
        QRCodeStructuredAppendReader.h
        QRCodeStructuredAppendReader.cpp
        BlackboxTestRunner.h
        BlackboxTestRunner.cpp
        ZXFilesystem.h
    )

    target_include_directories (ReaderTest PRIVATE ../../thirdparty/stb)

    target_link_libraries(ReaderTest
        ZXing::ZXing
        $<$<AND:$<CXX_COMPILER_ID:GNU>,$<VERSION_LESS:$<CXX_COMPILER_VERSION>,9.0>>:stdc++fs>
    )

    add_test(NAME ReaderTest COMMAND ReaderTest ${CMAKE_CURRENT_SOURCE_DIR}/../samples)
endif()

if (BUILD_WRITERS)
    add_executable (WriterTest TestWriterMain.cpp)

    target_include_directories (WriterTest PRIVATE ../../thirdparty/stb)

    target_link_libraries (WriterTest ZXing::ZXing)

    add_test(NAME WriterTest COMMAND WriterTest)
endif()

=== wrappers/gdiplus/CMakeLists.txt ===
if (${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR})
    # this is the top level project
    cmake_minimum_required (VERSION 2.8.12)

    project (ZXingGdiPlus)

    set (BUILD_WRITERS OFF CACHE BOOL "Check to include encoders")
    set (BUILD_READERS ON CACHE BOOL "Check to include decoders")
    set (LINK_CPP_STATICALLY OFF CACHE BOOL "MSVC only, check to link statically standard library (/MT and /MTd)")

    add_definitions (-DUNICODE -D_UNICODE)
    
    if (MSVC AND LINK_CPP_STATICALLY)
        set (CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} /MT")
        set (CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MT")
        set (CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} /MTd")
        set (CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MTd")
    endif()
endif()

if (NOT DEFINED BUILD_WRITERS)
    set (BUILD_WRITERS OFF)
endif()

if (NOT DEFINED BUILD_READERS)
    set (BUILD_READERS ON)
endif()

add_subdirectory (${CMAKE_CURRENT_SOURCE_DIR}/../../core ${CMAKE_BINARY_DIR}/ZXing)
    
set (LOCAL_COMMON_FILES
    GdiplusInit.h
    GdiplusInit.cpp
)
if (BUILD_READERS)
    set (DECODERS_FILES
        ImageReader.h
        ImageReader.cpp
        BarcodeReader.h
        BarcodeReader.cpp
    )
endif()
if (BUILD_WRITERS)
    set (ENCODERS_FILES
        ImageWriter.h
        ImageWriter.cpp
        BarcodeGenerator.h
        BarcodeGenerator.cpp
    )
endif()

source_group (Sources FILES
    ${LOCAL_COMMON_FILES}
    ${DECODERS_FILES}
    ${ENCODERS_FILES}
)

add_library (ZXingGdiPlus
    ${LOCAL_COMMON_FILES}
    ${DECODERS_FILES}
    ${ENCODERS_FILES}
)

target_include_directories (ZXingGdiPlus
    PUBLIC .
)

target_link_libraries (ZXingGdiPlus
    PRIVATE ZXing::ZXing gdiplus.lib
)

target_compile_options (ZXingGdiPlus
    PUBLIC -DGDIPVER=0x0110
)

=== wrappers/winrt/CMakeLists.txt ===
#
# This will create a Windows Runtime Component that can be consummed by any WinRT or UWP project.
# You need to specify -DCMAKE_SYSTEM_NAME=WindowsStore -DCMAKE_SYSTEM_VERSION=10.0 at command line
# to generate correctly UWP projects. You can also use Toolchain-Win10.cmake as tool chain file
# which defined these for you.
#
# You can add EXTENSION_SDK_OUTPUT variable to deploy the build as UWP Extension SDK
# e.g. -DEXTENSION_SDK_OUTPUT:STRING=<path_to_folder_parent_of_SDKManifest.xml>
#
cmake_minimum_required (VERSION 3.4.0)

project (ZXingWinRT)

set (CMAKE_CONFIGURATION_TYPES "RelWithDebInfo;Release" CACHE STRING "" FORCE)
set (WINRT ON)
set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /INCREMENTAL:NO" )

add_definitions (-DUNICODE -D_UNICODE)

if (MSVC)
    add_definitions (
        -DNOMINMAX
    )
endif()

include(TargetArch.cmake)
get_target_architecture (TARGET_ARCHITECTURE)
set (TARGET_ARCHITECTURE ${TARGET_ARCHITECTURE} CACHE INTERNAL "")
message (STATUS "Building for " ${TARGET_ARCHITECTURE})

if (NOT DEFINED EXTENSION_SDK_OUTPUT)
    set (EXTENSION_SDK_OUTPUT "" CACHE PATH "Path to folder parent of SDKManifest")
endif()

add_subdirectory (${CMAKE_CURRENT_SOURCE_DIR}/../../core ${CMAKE_BINARY_DIR}/ZXing)

file (GLOB SOURCE_FILES *.cpp)
file (GLOB HEADER_FILES *.h)

set (ROOT_NAMESPACE "ZXing")
set (OUTPUT_FILE_BASE_NAME "ZXing")

add_library (ZXingWinRT SHARED ${HEADER_FILES} ${SOURCE_FILES})

target_link_libraries (ZXingWinRT
    PRIVATE ZXing::ZXing
)

target_compile_options (ZXingWinRT PRIVATE
    -D_WINRT_DLL
    -ZW             # Consume Windows Runtime Extension
)

set_target_properties (ZXingWinRT PROPERTIES
    LINK_FLAGS "/WINMD"     # Generate Windows Metadata
    VS_GLOBAL_ROOTNAMESPACE "${ROOT_NAMESPACE}"
    OUTPUT_NAME ${OUTPUT_FILE_BASE_NAME}
)

set_target_properties (ZXingWinRT ZXing PROPERTIES
    VS_WINDOWS_TARGET_PLATFORM_MIN_VERSION "10.0.10240.0"
)

if (EXTENSION_SDK_OUTPUT)
    add_custom_command (TARGET ZXingWinRT POST_BUILD
        COMMAND ${CMAKE_COMMAND} ARGS -E copy_if_different "$<TARGET_FILE:ZXingWinRT>" "${EXTENSION_SDK_OUTPUT}/Redist/$<$<CONFIG:Release>:Retail>$<$<CONFIG:RelWithDebInfo>:Debug>/${TARGET_ARCHITECTURE}/$<TARGET_FILE_NAME:ZXingWinRT>"
        COMMAND ${CMAKE_COMMAND} ARGS -E copy_if_different "$<TARGET_FILE_DIR:ZXingWinRT>/${ROOT_NAMESPACE}.winmd" "${EXTENSION_SDK_OUTPUT}/References/CommonConfiguration/Neutral/${ROOT_NAMESPACE}.winmd"
        COMMAND ${CMAKE_COMMAND} ARGS -E copy_if_different "$<TARGET_FILE_DIR:ZXingWinRT>/${ROOT_NAMESPACE}.pri" "${EXTENSION_SDK_OUTPUT}/References/CommonConfiguration/Neutral/${ROOT_NAMESPACE}.pri"
    )
endif()

=== debian/changelog ===
zxing-cpp (1.1.0-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Wed, 05 Aug 2020 16:08:00 -0400

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,9 @@
 Priority: optional
 Maintainer: Boyuan Yang <byang@debian.org>
 Build-Depends:
- debhelper-compat (= 12),
- cmake (>= 3.1.2),
+ debhelper-compat (= 13),
+ cmake (>= 3.10),
+ qtbase5-dev,
 Rules-Requires-Root: no
 Standards-Version: 4.5.0
 Homepage: https://github.com/nu-book/zxing-cpp

## zxing-cpp 1.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required (VERSION 3.10)
 
-project (ZXing VERSION "1.1.0" LANGUAGES CXX)
+project (ZXing VERSION "1.1.1" LANGUAGES CXX)
 
 option (BUILD_WRITERS "Build with writer support (encoders)" ON)
 option (BUILD_READERS "Build with reader support (decoders)" ON)
@@ -69,6 +69,9 @@
 if (BUILD_PYTHON_MODULE)
     add_subdirectory (wrappers/python)
 endif()
+if (WIN32)
+    add_subdirectory (wrappers/gdiplus)
+endif()
 
 set (CMAKECONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/ZXing")

=== core/CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,11 @@
-cmake_minimum_required (VERSION 3.1.3)
-
-if (NOT DEFINED ENABLE_ENCODERS)
-    set (ENABLE_ENCODERS OFF)
-endif()
-
-if (NOT DEFINED ENABLE_DECODERS)
-    set (ENABLE_DECODERS ON)
+cmake_minimum_required (VERSION 3.10)
+
+if (NOT DEFINED BUILD_WRITERS)
+    set (BUILD_WRITERS OFF)
+endif()
+
+if (NOT DEFINED BUILD_READERS)
+    set (BUILD_READERS ON)
 endif()
 
 set (ZXING_CORE_DEFINES)
@@ -27,8 +27,6 @@
     set (ZXING_CORE_LOCAL_DEFINES ${ZXING_CORE_LOCAL_DEFINES}
         -Wall -Wextra -Wno-missing-braces)
 endif()
-
-set (CMAKE_CXX_STANDARD 14)
 
 
 ################# Source files
@@ -41,7 +39,11 @@
     src/BitHacks.h
     src/BitMatrix.h
     src/BitMatrix.cpp
+    src/BitMatrixCursor.h
+    src/BitMatrixIO.h
+    src/BitMatrixIO.cpp
     src/ByteArray.h
+    src/ByteMatrix.h
     src/CharacterSet.h
     src/CharacterSetECI.h
     src/CharacterSetECI.cpp
@@ -50,19 +52,26 @@
     src/GenericGF.cpp
     src/GenericGFPoly.h
     src/GenericGFPoly.cpp
+    src/GTIN.h
+    src/LogMatrix.h
+    src/Matrix.h
+    src/Pattern.h
+    src/Point.h
+    src/Quadrilateral.h
     src/TextUtfEncoding.h
     src/TextUtfEncoding.cpp
+    src/TritMatrix.h
     src/ZXBigInteger.h
     src/ZXBigInteger.cpp
     src/ZXConfig.h
-    src/ZXFilesystem.h
+    src/ZXFlags.h
     src/ZXNullable.h
     src/ZXNumeric.h
     src/ZXContainerAlgorithms.h
     src/ZXStrConvWorkaround.h
     src/ZXTestSupport.h
 )
-if (ENABLE_DECODERS)
+if (BUILD_READERS)
     set (COMMON_FILES ${COMMON_FILES}
         src/BinaryBitmap.h
         src/BitSource.h
@@ -104,7 +113,7 @@
         src/WhiteRectDetector.cpp
     )
 endif()
-if (ENABLE_ENCODERS)
+if (BUILD_WRITERS)
     set (COMMON_FILES ${COMMON_FILES}
         src/ByteMatrix.h
         src/ReedSolomonEncoder.h
@@ -119,7 +128,7 @@
 
 set (AZTEC_FILES
 )
-if (ENABLE_DECODERS)
+if (BUILD_READERS)
     set (AZTEC_FILES ${AZTEC_FILES}
         src/aztec/AZDecoder.h
         src/aztec/AZDecoder.cpp
@@ -130,7 +139,7 @@
         src/aztec/AZReader.cpp
     )
 endif()
-if (ENABLE_ENCODERS)
+if (BUILD_WRITERS)
     set (AZTEC_FILES ${AZTEC_FILES}
         src/aztec/AZEncodingState.h
         src/aztec/AZEncoder.h
@@ -147,7 +156,7 @@
 
 set (DATAMATRIX_FILES
 )
-if (ENABLE_DECODERS)
+if (BUILD_READERS)
     set (DATAMATRIX_FILES ${DATAMATRIX_FILES}
         src/datamatrix/DMBitMatrixParser.h
         src/datamatrix/DMBitMatrixParser.cpp
@@ -164,7 +173,7 @@
         src/datamatrix/DMReader.cpp
     )
 endif()
-if (ENABLE_ENCODERS)
+if (BUILD_WRITERS)
     set (DATAMATRIX_FILES ${DATAMATRIX_FILES}
         src/datamatrix/DMECEncoder.h
         src/datamatrix/DMECEncoder.cpp
@@ -184,7 +193,7 @@
 
 set (MAXICODE_FILES
 )
-if (ENABLE_DECODERS)
+if (BUILD_READERS)
     set (MAXICODE_FILES ${MAXICODE_FILES}
         src/maxicode/MCBitMatrixParser.h
         src/maxicode/MCBitMatrixParser.cpp
@@ -202,7 +211,7 @@
     src/oned/ODCode128Patterns.h
     src/oned/ODCode128Patterns.cpp
 )
-if (ENABLE_DECODERS)
+if (BUILD_READERS)
     set (ONED_FILES ${ONED_FILES}
         src/oned/ODCodabarReader.h
         src/oned/ODCodabarReader.cpp
@@ -240,7 +249,7 @@
         src/oned/ODUPCEReader.cpp
     )
 endif()
-if (ENABLE_ENCODERS)
+if (BUILD_WRITERS)
     set (ONED_FILES ${ONED_FILES}
         src/oned/ODCodabarWriter.h
         src/oned/ODCodabarWriter.cpp
@@ -268,7 +277,7 @@
 
 set (ONED_RSS_FILES
 )
-if (ENABLE_DECODERS)
+if (BUILD_READERS)
     set (ONED_RSS_FILES ${ONED_RSS_FILES}
         src/oned/rss/ODRSSDataCharacter.h
         src/oned/rss/ODRSSExpandedBinaryDecoder.h
@@ -289,7 +298,7 @@
 
 set (PDF417_FILES
 )
-if (ENABLE_DECODERS)
+if (BUILD_READERS)
     set (PDF417_FILES ${PDF417_FILES}
         src/pdf417/PDFBarcodeMetadata.h
         src/pdf417/PDFBarcodeValue.h
@@ -318,7 +327,7 @@
         src/pdf417/PDFScanningDecoder.cpp
     )
 endif()
-if (ENABLE_ENCODERS)
+if (BUILD_WRITERS)
     set (PDF417_FILES ${PDF417_FILES}
         src/pdf417/PDFCompaction.h
         src/pdf417/PDFEncoder.h
@@ -339,7 +348,7 @@
     src/qrcode/QRVersion.h
     src/qrcode/QRVersion.cpp
 )
-if (ENABLE_DECODERS)
+if (BUILD_READERS)
     set (QRCODE_FILES ${QRCODE_FILES}
         src/qrcode/QRAlignmentPattern.h
         src/qrcode/QRAlignmentPattern.cpp
@@ -368,7 +377,7 @@
         src/qrcode/QRReader.cpp
     )
 endif()
-if (ENABLE_ENCODERS)
+if (BUILD_WRITERS)
     set (QRCODE_FILES ${QRCODE_FILES}
         src/qrcode/QREncoder.h
         src/qrcode/QREncoder.cpp
@@ -389,7 +398,7 @@
     src/textcodec/KRHangulMapping.h
     src/textcodec/KRHangulMapping.cpp
 )
-if (ENABLE_DECODERS)
+if (BUILD_READERS)
     set (TEXT_CODEC_FILES ${TEXT_CODEC_FILES}
         src/textcodec/Big5TextDecoder.h
         src/textcodec/Big5TextDecoder.cpp
@@ -401,7 +410,7 @@
         src/textcodec/KRTextDecoder.cpp
     )
 endif()
-if (ENABLE_ENCODERS)
+if (BUILD_WRITERS)
     set (TEXT_CODEC_FILES ${TEXT_CODEC_FILES}
         src/textcodec/Big5TextEncoder.h
         src/textcodec/Big5TextEncoder.cpp
@@ -414,6 +423,3 @@
     )
 endif()
 
-source_group (Sources FILES ${COMMON_FILES})
-source_group (Sources\\aztec FILES ${AZTEC_FILES})
-source_group (Sources\\datamatrix FILES ${DATAMATRIX_FILES})

=== example/CMakeLists.txt ===
#show that it is possible to use the library (in its simples form) with a c++-11 compiler
set (CMAKE_CXX_STANDARD 11)

if (BUILD_READERS)
    add_executable (ZXingReader ZXingReader.cpp)

    target_include_directories (ZXingReader PRIVATE ../thirdparty/stb)

    target_link_libraries (ZXingReader ZXing::ZXing)

    add_test(NAME ZXingReaderTest COMMAND ZXingReader -fast -format qrcode "${CMAKE_SOURCE_DIR}/test/samples/qrcode-1/1.png")
endif()

if (BUILD_WRITERS)
    add_executable (ZXingWriter ZXingWriter.cpp)

    target_include_directories (ZXingWriter PRIVATE ../thirdparty/stb)

    target_link_libraries (ZXingWriter ZXing::ZXing)

    add_test(NAME ZXingWriterTest COMMAND ZXingWriter qrcode "I have the best words." test.png)
endif()

find_package (Qt5 5.5 COMPONENTS Gui)
if (TARGET Qt5::Gui)
    add_executable (ZXingQtReader ZXingQtReader.cpp)
    target_link_libraries(ZXingQtReader ZXing::ZXing Qt5::Gui)
endif()

=== test/blackbox/CMakeLists.txt ===
--- 
+++ 
@@ -21,6 +21,12 @@
         $<$<AND:$<CXX_COMPILER_ID:GNU>,$<VERSION_LESS:$<CXX_COMPILER_VERSION>,9.0>>:stdc++fs>
     )
 
+if (MSVC)
+    target_compile_options(ReaderTest PRIVATE
+        -D_CRT_SECURE_NO_WARNINGS
+    )
+endif()
+
     add_test(NAME ReaderTest COMMAND ReaderTest ${CMAKE_CURRENT_SOURCE_DIR}/../samples)
 endif()

=== test/unit/CMakeLists.txt ===

# Download and unpack googletest at configure time
configure_file (CMakeLists.txt.in googletest-download/CMakeLists.txt)
execute_process (COMMAND ${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}" .
    RESULT_VARIABLE result
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/googletest-download )
if (result)
    message (FATAL_ERROR "CMake step for googletest failed: ${result}")
endif()
execute_process (COMMAND ${CMAKE_COMMAND} --build .
    RESULT_VARIABLE result
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/googletest-download )
if (result)
    message (FATAL_ERROR "Build step for googletest failed: ${result}")
endif()

# Prevent overriding the parent project's compiler/linker
# settings on Windows
set (gtest_force_shared_crt ON CACHE BOOL "" FORCE)

# Add googletest directly to our build. This defines
# the gtest and gtest_main targets.
add_subdirectory (${CMAKE_CURRENT_BINARY_DIR}/googletest-src ${CMAKE_CURRENT_BINARY_DIR}/googletest-build EXCLUDE_FROM_ALL)


# Our executable
add_executable (UnitTest
    BarcodeFormatTest.cpp
    BitArrayUtility.h
    BitArrayUtility.cpp
    PseudoRandom.h
    BitHacksTest.cpp
    ReedSolomonTest.cpp
    aztec/AZDetectorTest.cpp
    aztec/AZDecoderTest.cpp
    aztec/AZEncoderTest.cpp
    aztec/AZEncodeDecodeTest.cpp
    aztec/AZHighLevelEncoderTest.cpp
    datamatrix/DMDecodedBitStreamParserTest.cpp
    datamatrix/DMEncodeDecodeTest.cpp
    datamatrix/DMHighLevelEncodeTest.cpp
    datamatrix/DMPlacementTest.cpp
    datamatrix/DMSymbolInfoTest.cpp
    datamatrix/DMWriterTest.cpp
    oned/ODCodaBarWriterTest.cpp
    oned/ODCode39ExtendedModeTest.cpp
    oned/ODCode39WriterTest.cpp
    oned/ODCode93ReaderTest.cpp
    oned/ODCode93WriterTest.cpp
    oned/ODCode128WriterTest.cpp
    oned/ODEAN8WriterTest.cpp
    oned/ODEAN13WriterTest.cpp
    oned/ODITFWriterTest.cpp
    oned/ODUPCAWriterTest.cpp
    oned/ODUPCEWriterTest.cpp
    qrcode/QRDataMaskTest.cpp
    qrcode/QRDecodedBitStreamParserTest.cpp
    qrcode/QREncoderTest.cpp
    qrcode/QRErrorCorrectionLevelTest.cpp
    qrcode/QRFormatInformationTest.cpp
    qrcode/QRModeTest.cpp
    qrcode/QRVersionTest.cpp
    qrcode/QRWriterTest.cpp
    pdf417/PDF417DecoderTest.cpp
    pdf417/PDF417ErrorCorrectionTest.cpp
    pdf417/PDF417HighLevelEncoderTest.cpp
    pdf417/PDF417WriterTest.cpp
)

target_include_directories (UnitTest PRIVATE .)

target_link_libraries (UnitTest ZXing::ZXing gtest_main)

add_test(NAME UnitTest COMMAND UnitTest)

=== wrappers/gdiplus/CMakeLists.txt ===
--- 
+++ 
@@ -16,18 +16,19 @@
         set (CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} /MTd")
         set (CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MTd")
     endif()
+
+    if (NOT DEFINED BUILD_WRITERS)
+        set (BUILD_WRITERS OFF)
+    endif()
+
+    if (NOT DEFINED BUILD_READERS)
+        set (BUILD_READERS ON)
+    endif()
+
+    add_subdirectory (${CMAKE_CURRENT_SOURCE_DIR}/../../core ${CMAKE_BINARY_DIR}/ZXingCore)
+    
 endif()
 
-if (NOT DEFINED BUILD_WRITERS)
-    set (BUILD_WRITERS OFF)
-endif()
-
-if (NOT DEFINED BUILD_READERS)
-    set (BUILD_READERS ON)
-endif()
-
-add_subdirectory (${CMAKE_CURRENT_SOURCE_DIR}/../../core ${CMAKE_BINARY_DIR}/ZXing)
-    
 set (LOCAL_COMMON_FILES
     GdiplusInit.h
     GdiplusInit.cpp

=== wrappers/python/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)
project(ZXingPython)

# get pybind11
include(FetchContent)
set(FETCHCONTENT_QUIET Off)
FetchContent_Declare (pybind11 GIT_REPOSITORY https://github.com/pybind/pybind11.git GIT_TAG v2.5.0)
FetchContent_MakeAvailable (pybind11)

# check if we are called from the top-level ZXing project
get_directory_property(hasParent PARENT_DIRECTORY)
if (NOT hasParent)
    option (BUILD_SHARED_LIBS "Link python module to shared lib" OFF)
    option (BUILD_WRITERS "Build with writer support (encoders)" ON)
    option (BUILD_READERS "Build with reader support (decoders)" ON)

    # build the main library
    if (NOT BUILD_SHARED_LIBS)
        set(CMAKE_POSITION_INDEPENDENT_CODE ON)
    endif()
    add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/../../core ZXing EXCLUDE_FROM_ALL)

    enable_testing()
endif()

# build the python module
pybind11_add_module(zxing zxing.cpp)
target_link_libraries(zxing PRIVATE ZXing::ZXing)

add_test(NAME PythonTest COMMAND python ${CMAKE_CURRENT_SOURCE_DIR}/test.py -v)
set_property(TEST PythonTest PROPERTY ENVIRONMENT PYTHONPATH=$<TARGET_FILE_DIR:zxing>)

=== wrappers/wasm/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.10)

project (ZXingWasm)

option (BUILD_WRITERS "Build with writer support (encoders)" ON)
option (BUILD_READERS "Build with reader support (decoders)" ON)

if (NOT CMAKE_BUILD_TYPE)
    set (CMAKE_BUILD_TYPE "MinSizeRel" CACHE STRING "Choose the type of build." FORCE)
endif()

add_definitions ("-s DISABLE_EXCEPTION_CATCHING=0")

add_subdirectory (${CMAKE_CURRENT_SOURCE_DIR}/../../core ${CMAKE_BINARY_DIR}/ZXing)

include_directories ("../../thirdparty/stb")

set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} --bind -s ENVIRONMENT=web -s DISABLE_EXCEPTION_CATCHING=0 -s FILESYSTEM=0 -s MODULARIZE=1 -s EXPORT_NAME=ZXing")

if (BUILD_READERS AND BUILD_WRITERS)
    add_executable (zxing BarcodeReader.cpp BarcodeWriter.cpp)
    target_link_libraries (zxing ZXing::ZXing)
endif()

if (BUILD_READERS)
    add_executable (zxing_reader BarcodeReader.cpp)
    target_link_libraries (zxing_reader ZXing::ZXing)
endif()

if (BUILD_WRITERS)
    add_executable (zxing_writer BarcodeWriter.cpp )
    target_link_libraries (zxing_writer ZXing::ZXing)
endif()

=== wrappers/winrt/CMakeLists.txt ===
--- 
+++ 
@@ -19,7 +19,7 @@
 
 if (MSVC)
     add_definitions (
-        -DNOMINMAX
+        -DNOMINMAX -wd4996
     )
 endif()
 
@@ -32,7 +32,7 @@
     set (EXTENSION_SDK_OUTPUT "" CACHE PATH "Path to folder parent of SDKManifest")
 endif()
 
-add_subdirectory (${CMAKE_CURRENT_SOURCE_DIR}/../../core ${CMAKE_BINARY_DIR}/ZXing)
+add_subdirectory (${CMAKE_CURRENT_SOURCE_DIR}/../../core ${CMAKE_BINARY_DIR}/ZXingCore)
 
 file (GLOB SOURCE_FILES *.cpp)
 file (GLOB HEADER_FILES *.h)

=== debian/changelog ===
zxing-cpp (1.1.1-2) unstable; urgency=medium

  * debian/control: Update build-dependency and package description
    according to upstream recommendation.
  * Rebuild before Debian 11 release.

 -- Boyuan Yang <byang@debian.org>  Sat, 19 Dec 2020 19:31:32 -0500

zxing-cpp (1.1.1-1) unstable; urgency=medium

  * New upstream release. 

 -- Boyuan Yang <byang@debian.org>  Wed, 16 Sep 2020 18:53:42 -0400

=== debian/control ===
Source: zxing-cpp
Section: libs
Priority: optional
Maintainer: Boyuan Yang <byang@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake (>= 3.10),
Rules-Requires-Root: no
Standards-Version: 4.5.1
Homepage: https://github.com/nu-book/zxing-cpp
Vcs-Git: https://salsa.debian.org/debian/zxing-cpp.git
Vcs-Browser: https://salsa.debian.org/debian/zxing-cpp

Package: libzxingcore-dev
Architecture: any
Section: libdevel
Depends:
 ${misc:Depends},
 libzxingcore1 (= ${binary:Version}),
Description: C++ port of ZXing library (development files)
 ZXing-C++ ("zebra crossing") is an open-source, multi-format 1D/2D
 barcode image processing library implemented in C++.
 .
 It was originally ported from the Java ZXing library but has been
 developed further and now includes many improvements in terms of
 quality and performance. It can both read and write barcodes in a
 number of formats:  QR Code, DataMatrix, Aztec, PDF417, UPC-A, UPC-E,
 EAN-8, EAN-13, DataBar/RSS, Code 39, Code 93, Code 128, Codabar, ITF.
 .
 This package provides development files for zxing-cpp library.

Package: libzxingcore1
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: C++ port of ZXing library (library files)
 ZXing-C++ ("zebra crossing") is an open-source, multi-format 1D/2D
 barcode image processing library implemented in C++.
 .
 It was originally ported from the Java ZXing library but has been
 developed further and now includes many improvements in terms of
 quality and performance. It can both read and write barcodes in a
 number of formats:  QR Code, DataMatrix, Aztec, PDF417, UPC-A, UPC-E,
 EAN-8, EAN-13, DataBar/RSS, Code 39, Code 93, Code 128, Codabar, ITF.
 .
 This package provides library files for zxing-cpp library.

=== debian/rules ===
--- 
+++ 
@@ -10,10 +10,9 @@
 # # package maintainers to append CFLAGS
 # #export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
 # # package maintainers to append LDFLAGS
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
+#export DEB_LDFLAGS_MAINT_APPEND =
+
+export QT_SELECT := 5
 
 %:
 	dh $@
-
-override_dh_missing:
-	dh_missing --fail-missing

=== debian/watch ===
version=4
opts=" \
 filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%zxing-cpp_$1.orig.tar.gz%" \
 https://github.com/nu-book/zxing-cpp/tags \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
